﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32.SafeHandles;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Security.Cryptography;


namespace wxRipper
{

    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private const int CB_CDROMSECTOR = 0x800;
        private const int CB_GAPMAXLBA = 0x7a120;
        private const int CB_GROUPSECTOR = 0x400;
        private const int CB_LAYER1LBA = 0x1b3880;
        private const int CB_XDVDFSLBA = 0x1fb20;
        public const uint CREATE_ALWAYS = 2;
        public const uint CREATE_NEW = 1;
        private const uint FILE_ANY_ACCESS = 0;
        private const uint FILE_DEVICE_UNKNOWN = 0x22;
        public const uint FILE_SHARE_DELETE = 4;
        public const uint FILE_SHARE_READ = 1;
        public const uint FILE_SHARE_WRITE = 2;
        public const uint GENERIC_ALL = 0x10000000;
        public const uint GENERIC_EXECUTE = 0x20000000;
        public const uint GENERIC_READ = 0x80000000;
        public const uint GENERIC_WRITE = 0x40000000;
        public const uint INVALID_HANDLE_VALUE = uint.MaxValue;
        public const uint IOCTL_STORAGE_EJECT_MEDIA = 0x2d4808;
        public const uint IOCTL_STORAGE_LOAD_MEDIA = 0x2d480c;
        public const uint IOCTL_STORAGE_MEDIA_REMOVAL = 0x2d4804;
        private long magic_number;
        private const uint METHOD_BUFFERED = 0;
        private const uint METHOD_IN_DIRECT = 1;
        private const uint METHOD_NEITHER = 3;
        private const uint METHOD_OUT_DIRECT = 2;
        public const uint OPEN_ALWAYS = 4;
        public const uint OPEN_EXISTING = 3;
        public const uint TRUNCATE_EXISTING = 5;
        private const int wxMN_ERROR_NO_DVD = -4;
        private const int wxMN_ERROR_NO_DVD9 = -8;
        private const int wxMN_ERROR_NO_MEDIA = -2;
        private const int wxMN_ERROR_TO_SMALL = -16;

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            new AboutBox().ShowDialog();
        }

        private void addGame(object sender, EventArgs e)
        {
            SafeFileHandle handle;
            FileStream stream;
            BinaryReader reader;
            byte[] data = new byte[0x800];
            try
            {
                handle = CreateFile(string.Format(@"\\.\{0}:", this.driveToolStripComboBox.Text[0]), 0x80000000, 1, IntPtr.Zero, 3, 0, IntPtr.Zero);
                stream = new FileStream(handle, FileAccess.Read);
                reader = new BinaryReader(stream);
            }
            catch (IOException exception)
            {
                this.textBoxLog.AppendText(string.Format("Error opening drive : {0}\r\n", exception.Message));
                return;
            }
            try
            {
                reader.BaseStream.Seek(0xfd90000L, SeekOrigin.Begin);
                for (int i = 0; i < 10; i++)
                {
                    reader.ReadBytes(0x200000);
                    Application.DoEvents();
                }
                reader.BaseStream.Seek(0xfd90000L, SeekOrigin.Begin);
                data = reader.ReadBytes(0x800);
            }
            catch (IOException exception2)
            {
                reader.Close();
                stream.Close();
                handle.Close();
                this.textBoxLog.AppendText(string.Format("Error reading drive : {0}\r\n", exception2.Message));
                this.slowDrive();
                this.stopDrive();
                return;
            }
            string str = GetMd5Sum(data);
            if (!(this.GetHash(str) != ""))
            {
                try
                {
                    reader.BaseStream.Seek((0x1d33a0L + this.magic_number) * 0x800L, SeekOrigin.Begin);
                    data = reader.ReadBytes(0x800);
                }
                catch (IOException exception3)
                {
                    reader.Close();
                    stream.Close();
                    handle.Close();
                    this.textBoxLog.AppendText(string.Format("Error reading drive : {0}\r\n", exception3.Message));
                    this.slowDrive();
                    this.stopDrive();
                    return;
                }
                string str2 = GetMd5Sum(data);
                GameForm form = new GameForm();
                form.textBoxLayer0.Text = str;
                form.textBoxLayer1.Text = str2;
                form.textBoxGame.Focus();
                if (form.ShowDialog() == DialogResult.OK)
                {
                    string str3 = form.textBoxGame.Text + "\t" + form.textBoxLayer0.Text + "\t" + form.textBoxLayer1.Text;
                    TextWriter writer = new StreamWriter(Application.ExecutablePath.Substring(0, Application.ExecutablePath.LastIndexOf(".")) + ".db", true);
                    writer.WriteLine(str3);
                    writer.Close();
                }
                form.Dispose();
                reader.Close();
                stream.Close();
                CloseHandle(handle.DangerousGetHandle());
                handle.Dispose();
                Application.DoEvents();
                this.slowDrive();
                this.stopDrive();
            }
            else
            {
                this.textBoxLog.AppendText("Game already in database!\r\n");
                reader.Close();
                stream.Close();
                handle.Close();
                this.slowDrive();
                this.stopDrive();
            }
        }

        private void addItem(ListView listView, int LBA, int size, string cmd)
        {
            ListViewItem item = new ListViewItem();
            item.Text = cmd;
            if (cmd == "Copy")
            {
                item.ImageIndex = 0;
            }
            else if (cmd == "Dummy")
            {
                item.ImageIndex = 1;
            }
            if (cmd == "Jump")
            {
                item.ImageIndex = 2;
            }
            item.SubItems.Add(LBA.ToString());
            item.SubItems.Add(size.ToString());
            item.SubItems.Add("");
            listView.Items.Add(item);
        }

        [DllImport("Kernel32.dll", SetLastError = true)]
        public static extern int CloseHandle(IntPtr hObject);
        private void comboFocus(object sender, EventArgs e)
        {
            this.hotswapToolStrip.Focus();
            this.toolStripStatusLabelMZ.Text = "";
            this.addGameToolStripButton.Enabled = false;
            this.addGameToolStripMenuItem.Enabled = false;
            this.exploreToolStripButton.Enabled = false;
            this.explorerToolStripMenuItem.Enabled = false;
        }

        private void copy(ListViewItem listViewItem, BinaryReader br, BinaryWriter bw)
        {
            int num = Convert.ToInt32(listViewItem.SubItems[this.columnHeaderSize.Index].Text);
            int num2 = num / 0x400;
            int num3 = num - (num2 * 0x400);
            byte[] buffer = new byte[0x200000];
            for (uint i = 0; i < (num2 * 0x400); i += 0x400)
            {
                string str = string.Format("{0}", i);
                if (str != listViewItem.SubItems[this.columnHeaderStatus.Index].Text)
                {
                    listViewItem.SubItems[this.columnHeaderStatus.Index].Text = str;
                }
                Application.DoEvents();
                try
                {
                    buffer = br.ReadBytes(0x200000);
                }
                catch (IOException exception)
                {
                    this.textBoxLog.AppendText(string.Format("Error @ {0} : {1}\r\n", i, exception.Message));
                    return;
                }
                bw.Write(buffer);
            }
            buffer = br.ReadBytes(0x800 * num3);
            bw.Write(buffer);
            listViewItem.SubItems[this.columnHeaderStatus.Index].Text = "Done";
        }

        [DllImport("Kernel32.dll", SetLastError = true)]
        public static extern SafeFileHandle CreateFile(string FileName, uint DesiredAccess, uint ShareMode, IntPtr lpSecurityAttributes, uint CreationDisposition, uint dwFlagsAndAttributes, IntPtr hTemplateFile);
        public static uint CTL_CODE(uint DeviceType, uint Function, uint Method, uint Access)
        {
            return ((((DeviceType << 0x10) | (Access << 14)) | (Function << 2)) | Method);
        }

        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int DeviceIoControl(IntPtr hDevice, int dwIoControlCode, byte[] lpInBuffer, int nInBufferSize, byte[] lpOutBuffer, int nOutBufferSize, ref int lpBytesReturned, IntPtr lpOverlapped);
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int DeviceIoControl(IntPtr hDevice, int dwIoControlCode, IntPtr lpInBuffer, int nInBufferSize, IntPtr lpOutBuffer, int nOutBufferSize, ref int lpBytesReturned, IntPtr lpOverlapped);
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int DeviceIoControl(IntPtr hDevice, int dwIoControlCode, SCSI_PASS_THROUGH_DIRECT_WITH_BUFFERS lpInBuffer, int nInBufferSize, SCSI_PASS_THROUGH_DIRECT_WITH_BUFFERS lpOutBuffer, int nOutBufferSize, ref int lpBytesReturned, IntPtr lpOverlapped);
        [DllImport("kernel32.dll", SetLastError = true)]
        private static extern int DeviceIoControl(IntPtr hDevice, int dwIoControlCode, SCSI_PASS_THROUGH_WITH_BUFFERS lpInBuffer, int nInBufferSize, SCSI_PASS_THROUGH_WITH_BUFFERS lpOutBuffer, int nOutBufferSize, ref int lpBytesReturned, IntPtr lpOverlapped);


        private void dummy(ListViewItem listViewItem, BinaryReader br, BinaryWriter bw)
        {
            int num = Convert.ToInt32(listViewItem.SubItems[this.columnHeaderSize.Index].Text);
            int num2 = num / 0x400;
            int num3 = num - (num2 * 0x400);
            byte[] buffer = new byte[0x200000];
            for (uint i = 0; i < (num2 * 0x400); i += 0x400)
            {
                string str = string.Format("{0}", i);
                if (str != listViewItem.SubItems[this.columnHeaderStatus.Index].Text)
                {
                    listViewItem.SubItems[this.columnHeaderStatus.Index].Text = str;
                }
                Application.DoEvents();
                br.BaseStream.Seek(0x200000L, SeekOrigin.Current);
                bw.Write(buffer, 0, 0x200000);
            }
            br.BaseStream.Seek(0x800L * num3, SeekOrigin.Current);
            bw.Write(buffer, 0, 0x800 * num3);
            listViewItem.SubItems[this.columnHeaderStatus.Index].Text = "Done";
        }

        private void dumpDisc(object sender, EventArgs e)
        {
            if (this.saveFileDialogIso.ShowDialog() == DialogResult.OK)
            {
                SafeFileHandle handle;
                FileStream stream;
                FileStream stream2;
                BinaryReader reader;
                BinaryWriter writer;
                this.textBoxLog.AppendText(DateTime.Now.ToLongTimeString() + " -> Start\r\n");
                try
                {
                    handle = CreateFile(string.Format(@"\\.\{0}:", this.driveToolStripComboBox.Text[0]), 0x80000000, 1, IntPtr.Zero, 3, 0, IntPtr.Zero);
                    stream = new FileStream(handle, FileAccess.Read);
                    reader = new BinaryReader(stream);
                }
                catch (IOException exception)
                {
                    this.textBoxLog.AppendText(string.Format("Error opening drive : {0}\r\n", exception.Message));
                    return;
                }
                try
                {
                    stream2 = new FileStream(this.saveFileDialogIso.FileName, FileMode.Create, FileAccess.Write, FileShare.None);
                    writer = new BinaryWriter(stream2);
                }
                catch (IOException exception2)
                {
                    this.textBoxLog.AppendText(string.Format("Error opening drive : {0}\r\n", exception2.Message));
                    return;
                }
                for (int i = 0; i < this.listView.Items.Count; i++)
                {
                    if (this.listView.Items[i].SubItems[this.columnHeaderAction.Index].Text == "Copy")
                    {
                        this.copy(this.listView.Items[i], reader, writer);
                    }
                    else if (this.listView.Items[i].SubItems[this.columnHeaderAction.Index].Text == "Dummy")
                    {
                        this.dummy(this.listView.Items[i], reader, writer);
                    }
                    else if (this.listView.Items[i].SubItems[this.columnHeaderAction.Index].Text == "Jump")
                    {
                        this.jump(this.listView.Items[i], reader);
                    }
                }
                reader.Close();
                stream.Close();
                writer.Close();
                stream2.Close();
                CloseHandle(handle.DangerousGetHandle());
                handle.Dispose();
                this.textBoxLog.AppendText(DateTime.Now.ToLongTimeString() + " -> Done\r\n");
                this.slowDrive();
                this.stopDrive();
            }
        }

        private void ejectDrive()
        {
            byte[] cmd = new byte[6];
            cmd[0] = 0x1b;
            cmd[1] = 1;
            cmd[4] = 2;
            this.send(this.driveToolStripComboBox.Text[0], cmd);
        }

        private void ejectDrive(object sender, EventArgs e)
        {
            this.ejectDrive();
        }

        private void exit(object sender, EventArgs e)
        {
            this.Dispose(true);
        }

        private void explore(object sender, EventArgs e)
        {
            ShellExecute(base.Handle, "open", "wx360.exe", string.Format("{0} {1}", this.driveToolStripComboBox.Text[0], this.magic_number), Application.StartupPath, 1);
        }

        private static string ExtractFilename(string fullname)
        {
            int num = fullname.LastIndexOf('\\');
            return fullname.Substring(num + 1, (fullname.Length - num) - 1);
        }

        private void fillSPTDB(byte[] cmd, ref SPTDB sptdb)
        {
            sptdb.length = 0x2c;
            sptdb.ScsiStatus = 0;
            sptdb.PathId = 0;
            sptdb.TargetId = 0;
            sptdb.Lun = 0;
            sptdb.SenseInfoLength = 0x23;
            sptdb.SenseInfoOffset = 0x2c;
            sptdb.TimeOutValue = 10;
            sptdb.cdb = new byte[0xff];
            sptdb.Fill = new byte[4];
            sptdb.SenseBuffer = new byte[0x23];
            for (int i = 0; i < cmd.Length; i++)
            {
                sptdb.cdb[i] = cmd[i];
            }
            sptdb.CdbLength = 6;
            sptdb.DataIn = 1;
            sptdb.DataTransfertLength = 0;
            sptdb.DataBuffer = null;
        }

        private void findMagicNumber(object sender, EventArgs e)
        {
            SafeFileHandle handle;
            FileStream stream;
            BinaryReader reader;
            byte[] buffer = new byte[0x200000];
            byte[] data = new byte[0x800];
            long num = 0x7a120L;
            bool flag = false;
            this.addGameToolStripButton.Enabled = false;
            this.addGameToolStripMenuItem.Enabled = false;
            this.exploreToolStripButton.Enabled = false;
            this.explorerToolStripMenuItem.Enabled = false;
            try
            {
                handle = CreateFile(string.Format(@"\\.\{0}:", this.driveToolStripComboBox.Text[0]), 0x80000000, 1, IntPtr.Zero, 3, 0, IntPtr.Zero);
                stream = new FileStream(handle, FileAccess.Read);
                reader = new BinaryReader(stream);
            }
            catch (IOException exception)
            {
                this.textBoxLog.AppendText(string.Format("Error opening drive : {0}\r\n", exception.Message));
                return;
            }
            try
            {
                reader.BaseStream.Seek(0xfd90000L, SeekOrigin.Begin);
                for (int i = 0; i < 10; i++)
                {
                    reader.ReadBytes(0x200000);
                }
                reader.BaseStream.Seek(0xfd90000L, SeekOrigin.Begin);
                data = reader.ReadBytes(0x800);
            }
            catch (IOException exception2)
            {
                reader.Close();
                stream.Close();
                handle.Close();
                this.textBoxLog.AppendText(string.Format("Error reading drive : {0}\r\n", exception2.Message));
                return;
            }
            string str = GetMd5Sum(data);
            string hash = this.GetHash(str);
            if (!(hash == ""))
            {
                this.textBoxLog.AppendText("Searching Layer1 offset...\r\n");
                reader.BaseStream.Seek((0x1d33a0L + num) * 0x800L, SeekOrigin.Begin);
                for (long j = num; j >= 0L; j -= 0x400L)
                {
                    buffer = reader.ReadBytes(0x200000);
                    for (int k = 0x3ff; k >= 0; k--)
                    {
                        for (int m = 0; m < 0x800; m++)
                        {
                            data[m] = buffer[(k * 0x800) + m];
                        }
                        if (hash == GetMd5Sum(data))
                        {
                            this.textBoxLog.AppendText(string.Format("Found magic number : {0}\r\n", j + k));
                            this.makeLayout(j + k);
                            this.magic_number = j + k;
                            this.toolStripStatusLabelMZ.Text = this.magic_number.ToString();
                            this.addGameToolStripButton.Enabled = true;
                            this.addGameToolStripMenuItem.Enabled = true;
                            this.exploreToolStripButton.Enabled = true;
                            this.explorerToolStripMenuItem.Enabled = true;
                            flag = true;
                            break;
                        }
                        Application.DoEvents();
                        if (flag)
                        {
                            break;
                        }
                        this.toolStripStatusLabelMZ.Text = j.ToString();
                        Application.DoEvents();
                    }
                    if (flag)
                    {
                        break;
                    }
                    reader.BaseStream.Seek(-4194304L, SeekOrigin.Current);
                }
            }
            else
            {
                this.textBoxLog.AppendText("Game not found!\r\n");
                this.findMagicNumber2(reader);
                reader.Close();
                stream.Close();
                handle.Close();
                this.stopDrive(sender, e);
                return;
            }
            reader.Close();
            stream.Close();
            CloseHandle(handle.DangerousGetHandle());
            handle.Dispose();
            Application.DoEvents();
            this.slowDrive();
            this.stopDrive();
        }

        private void findMagicNumber2(BinaryReader br)
        {
            this.textBoxLog.AppendText("Trying 'unknow game' method...\r\n");
            byte[] buffer = new byte[0x200000];
            byte[] data = new byte[0x800];
            long num = 0x7a120L;
            bool flag = false;
            string str = "C99A74C555371A433D121F551D6C6398";
            int num2 = 0;
            try
            {
                br.BaseStream.Seek((0x1d33a0L + num) * 0x800L, SeekOrigin.Begin);
            }
            catch (IOException exception)
            {
                this.textBoxLog.AppendText(string.Format("Error, maybe your hotswap DVD is too small !\r\nThe error message was: {0}\r\n", exception.Message));
                return;
            }
            for (long i = num; i >= 0L; i -= 0x400L)
            {
                try
                {
                    buffer = br.ReadBytes(0x200000);
                }
                catch (IOException exception2)
                {
                    this.textBoxLog.AppendText(string.Format("{0}\r\n", exception2.Message));
                    break;
                }
                for (int j = 0x3ff; j >= 0; j--)
                {
                    for (int k = 0; k < 0x800; k++)
                    {
                        data[k] = buffer[(j * 0x800) + k];
                    }
                    if (str == GetMd5Sum(data))
                    {
                        num2++;
                    }
                    else
                    {
                        num2 = 0;
                    }
                    if (num2 == 0x400)
                    {
                        this.magic_number = (i + j) + 0x400L;
                        this.textBoxLog.AppendText(string.Format("Found magic number : {0}\r\n", this.magic_number));
                        Application.DoEvents();
                        this.makeLayout(this.magic_number);
                        this.toolStripStatusLabelMZ.Text = this.magic_number.ToString();
                        this.addGameToolStripButton.Enabled = true;
                        this.addGameToolStripMenuItem.Enabled = true;
                        this.exploreToolStripButton.Enabled = true;
                        this.explorerToolStripMenuItem.Enabled = true;
                        flag = true;
                        break;
                    }
                    Application.DoEvents();
                    if (flag)
                    {
                        break;
                    }
                    this.toolStripStatusLabelMZ.Text = i.ToString();
                    Application.DoEvents();
                }
                if (flag)
                {
                    return;
                }
                br.BaseStream.Seek(-4194304L, SeekOrigin.Current);
            }
        }

        private void findMagicNumberDLL(object sender, EventArgs e)
        {
            int num = getMN(this.driveToolStripComboBox.Text[0]);
            switch (num)
            {
                case -2:
                    this.textBoxLog.AppendText("Error : no media loaded\r\n");
                    return;

                case -4:
                    this.textBoxLog.AppendText("Error : the loaded media isn't a DVD\r\n");
                    return;

                case -8:
                    this.textBoxLog.AppendText("Error : the loaded media isn't a DVD9\r\n");
                    return;

                case -16:
                    this.textBoxLog.AppendText("Error : hotswap DVD is too small\r\n\r\n");
                    return;
            }
            this.magic_number = num;
            this.textBoxLog.AppendText(string.Format("Found magic number : {0}\r\n", this.magic_number));
            this.toolStripStatusLabelMZ.Text = this.magic_number.ToString();
            this.addGameToolStripButton.Enabled = true;
            this.addGameToolStripMenuItem.Enabled = true;
            this.exploreToolStripButton.Enabled = true;
            this.explorerToolStripMenuItem.Enabled = true;
            this.makeLayout(this.magic_number);
        }

        [DllImport("kernel32.dll", EntryPoint = "GetDriveTypeA")]
        public static extern uint GetDriveType(string nDrive);
        private string GetHash(string Layer0)
        {
            string str2;
            TextReader reader;
            string path = Application.ExecutablePath.Substring(0, Application.ExecutablePath.LastIndexOf(".")) + ".db";
            string str3 = "";
            try
            {
                reader = new StreamReader(path);
                goto Label_00A2;
            }
            catch (IOException exception)
            {
                this.textBoxLog.AppendText(string.Format("Error opening game database : {0}\r\n", exception.Message));
                return "";
            }
        Label_005B:
            if (str2.IndexOf(Layer0) > 0)
            {
                this.textBoxLog.AppendText(string.Format("Found game : {0}\r\n", str2.Substring(0, str2.IndexOf("\t"))));
                str3 = str2.Substring(str2.LastIndexOf("\t") + 1);
                goto Label_00AC;
            }
        Label_00A2:
            if ((str2 = reader.ReadLine()) != null)
            {
                goto Label_005B;
            }
        Label_00AC:
            reader.Close();
            return str3;
        }

        private static string GetMd5Sum(byte[] data)
        {
            byte[] buffer = new MD5CryptoServiceProvider().ComputeHash(data);
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < buffer.Length; i++)
            {
                builder.Append(buffer[i].ToString("X2"));
            }
            return builder.ToString();
        }

        [DllImport("wxMN.dll", SetLastError = true)]
        private static extern int getMN(char c);
        [DllImport("kernel32.dll", EntryPoint = "GetVolumeInformationA")]
        public static extern long GetVolumeInformation(string lpRootPathName, StringBuilder lpVolumeNameBuffer, int nVolumeNameSize, int lpVolumeSerialNumber, int lpMaximumComponentLength, uint lpFileSystemFlags, StringBuilder lpFileSystemNameBuffer, int nFileSystemNameSize);

        private void jump(ListViewItem listViewItem, BinaryReader br)
        {
            int num = Convert.ToInt32(listViewItem.SubItems[this.columnHeaderSize.Index].Text);
            int num2 = num / 0x400;
            int num3 = num - (num2 * 0x400);
            for (uint i = 0; i < (num2 * 0x400); i += 0x400)
            {
                string str = string.Format("{0}", i);
                if (str != listViewItem.SubItems[this.columnHeaderStatus.Index].Text)
                {
                    listViewItem.SubItems[this.columnHeaderStatus.Index].Text = str;
                }
                Application.DoEvents();
                br.BaseStream.Seek(0x200000L, SeekOrigin.Current);
            }
            br.BaseStream.Seek(0x800L * num3, SeekOrigin.Current);
            listViewItem.SubItems[this.columnHeaderStatus.Index].Text = "Done";
        }

        private void loadDrive()
        {
            byte[] cmd = new byte[6];
            cmd[0] = 0x1b;
            cmd[1] = 1;
            cmd[4] = 3;
            this.send(this.driveToolStripComboBox.Text[0], cmd);
        }

        private void loadDrive(object sender, EventArgs e)
        {
            this.loadDrive();
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            StringBuilder lpVolumeNameBuffer = new StringBuilder(0x100);
            StringBuilder lpFileSystemNameBuffer = new StringBuilder(0x100);
            int lpVolumeSerialNumber = 0;
            int lpMaximumComponentLength = 0;
            uint lpFileSystemFlags = 0;
            this.toolStripStatusLabel.Text = string.Format("{0} - {1}", Application.ProductName, Assembly.GetExecutingAssembly().GetName().Version.ToString());
            string[] logicalDrives = Directory.GetLogicalDrives();
            for (int i = 0; i < logicalDrives.Length; i++)
            {
                lpVolumeNameBuffer.Length = 0;
                lpFileSystemNameBuffer.Length = 0;
                GetVolumeInformation(logicalDrives[i], lpVolumeNameBuffer, lpVolumeNameBuffer.Capacity, lpVolumeSerialNumber, lpMaximumComponentLength, lpFileSystemFlags, lpFileSystemNameBuffer, lpFileSystemNameBuffer.Capacity);
                if (GetDriveType(logicalDrives[i]) == 5)
                {
                    if (lpFileSystemNameBuffer.Length > 0)
                    {
                        this.driveToolStripComboBox.Items.Add(string.Format("{0} {1} [{2}]", logicalDrives[i], lpVolumeNameBuffer, lpFileSystemNameBuffer));
                    }
                    else
                    {
                        this.driveToolStripComboBox.Items.Add(string.Format("{0} {1}", logicalDrives[i], lpVolumeNameBuffer));
                    }
                }
            }
            if (logicalDrives.Length > 0)
            {
                this.driveToolStripComboBox.SelectedIndex = 0;
            }
        }

        private void makeLayout(long magic_gap)
        {
            this.listView.Items.Clear();
            this.Text = "wxRipper";
            int lBA = 0;
            this.addItem(this.listView, lBA, 0x4bd0, "Copy");
            lBA += 0x4bd0;
            this.addItem(this.listView, lBA, 0x430, "Dummy");
            lBA += 0x430;
            this.addItem(this.listView, lBA, 0x1ab20, "Copy");
            lBA += 0x1ab20;
            this.addItem(this.listView, lBA, 0x1b3880, "Copy");
            lBA += 0x1b3880;
            this.addItem(this.listView, lBA, (int)magic_gap, "Jump");
            lBA += (int)magic_gap;
            this.addItem(this.listView, lBA, 0x1b3880, "Copy");
            lBA += 0x1b3880;
            this.addItem(this.listView, lBA, 0, "Jump");
        }

        private byte[] mmc(char c, byte[] cmd, byte size, uint buffsize)
        {
            SafeFileHandle handle;
            byte[] buffer = new byte[0x7d0];
            try
            {
                handle = CreateFile(string.Format(@"\\.\{0}:", c), 0xc0000000, 1, IntPtr.Zero, 3, 0, IntPtr.Zero);
            }
            catch (IOException exception)
            {
                this.textBoxLog.AppendText(string.Format("Error opening drive : {0}\r\n", exception.Message));
                return null;
            }
            SCSI_PASS_THROUGH_DIRECT_WITH_BUFFERS structure = new SCSI_PASS_THROUGH_DIRECT_WITH_BUFFERS(0, 10, 0x7d0);
            structure.spt.CdbLength = size;
            structure.spt.Length = (ushort)Marshal.SizeOf(typeof(SCSI_PASS_THROUGH_DIRECT));
            structure.spt.SenseInfoLength = 0x20;
            structure.spt.SenseInfoOffset = 0x30;
            structure.spt.TimeOutValue = 10;
            for (int i = 0; i < size; i++)
            {
                structure.spt.Cdb[i] = cmd[i];
            }
            structure.spt.DataIn = 1;
            structure.spt.DataTransferLength = buffsize;
            int length = Marshal.SizeOf(structure);
            structure.spt.DataBuffer = buffer;
            IntPtr ptr = new IntPtr();
            ptr = Marshal.AllocHGlobal(Marshal.SizeOf(structure));
            Marshal.StructureToPtr(structure, ptr, false);
            byte[] destination = new byte[length];
            byte[] buffer3 = new byte[length];
            Marshal.Copy(ptr, destination, 0, length);
            Marshal.Copy(ptr, buffer3, 0, length);
            int lpBytesReturned = 0;
            try
            {
                DeviceIoControl(handle.DangerousGetHandle(), 0x4d014, destination, length, buffer3, length, ref lpBytesReturned, IntPtr.Zero);
                if (lpBytesReturned == -1)
                {
                    throw new Win32Exception(Marshal.GetLastWin32Error());
                }
            }
            catch (Win32Exception exception2)
            {
                this.textBoxLog.AppendText(string.Format("{0}\r\n", exception2.Message));
            }
            for (int j = 0; j < 0x10; j++)
            {
                this.textBoxLog.AppendText(string.Format("{0:X2} ", buffer[j]));
            }
            this.textBoxLog.AppendText("\r\n");
            handle.Close();
            handle.Dispose();
            return null;
        }

        private void openLayoutFile(object sender, EventArgs e)
        {
            if (this.openFileDialog.ShowDialog() == DialogResult.OK)
            {
                this.listView.Items.Clear();
                this.Text = "wxRipper - " + ExtractFilename(this.openFileDialog.FileName);
                TextReader reader = new StreamReader(this.openFileDialog.FileName);
                string str = "";
                uint num = 0;
                uint num2 = 0;
                while ((str = reader.ReadLine()) != null)
                {
                    ListViewItem item = new ListViewItem();
                    num2 = Convert.ToUInt32(str.Substring(1));
                    if (str.Substring(0, 1) == "C")
                    {
                        item.Text = "Copy";
                        item.ImageIndex = 0;
                    }
                    else if (str.Substring(0, 1) == "D")
                    {
                        item.Text = "Dummy";
                        item.ImageIndex = 1;
                    }
                    else if (str.Substring(0, 1) == "J")
                    {
                        item.Text = "Jump";
                        item.ImageIndex = 2;
                    }
                    item.SubItems.Add(num.ToString());
                    item.SubItems.Add(num2.ToString());
                    item.SubItems.Add("");
                    this.listView.Items.Add(item);
                    num += num2;
                }
                reader.Close();
            }
        }

        private void saveLayoutFile(object sender, EventArgs e)
        {
            if (this.saveFileDialog.ShowDialog() == DialogResult.OK)
            {
                TextWriter writer;
                try
                {
                    writer = new StreamWriter(this.saveFileDialog.FileName, true);
                }
                catch (IOException exception)
                {
                    this.textBoxLog.AppendText(string.Format("{0}\r\n", exception.Message));
                    return;
                }
                for (int i = 0; i < this.listView.Items.Count; i++)
                {
                    string str = this.listView.Items[i].SubItems[this.columnHeaderAction.Index].Text.Substring(0, 1) + this.listView.Items[i].SubItems[this.columnHeaderSize.Index].Text;
                    writer.WriteLine(str);
                }
                writer.Close();
            }
        }

        private void send(char c, byte[] cmd)
        {
            SafeFileHandle handle;
            try
            {
                handle = CreateFile(string.Format(@"\\.\{0}:", c), 0xc0000000, 1, IntPtr.Zero, 3, 0, IntPtr.Zero);
            }
            catch (IOException)
            {
                return;
            }
            SPTDB sptdb = new SPTDB();
            this.fillSPTDB(cmd, ref sptdb);
            try
            {
                if (this.sendCommand(handle.DangerousGetHandle(), sptdb) == -1)
                {
                    throw new Win32Exception(Marshal.GetLastWin32Error());
                }
            }
            catch (Win32Exception)
            {
            }
            handle.Close();
            handle.Dispose();
        }

        private int sendCommand(IntPtr hDevice, SPTDB sptdb)
        {
            int cb = Marshal.SizeOf(sptdb);
            byte[] destination = new byte[cb];
            byte[] buffer2 = new byte[cb];
            IntPtr ptr = Marshal.AllocHGlobal(cb);
            Marshal.StructureToPtr(sptdb, ptr, false);
            Marshal.Copy(ptr, destination, 0, cb);
            Marshal.Copy(ptr, buffer2, 0, cb);
            int lpBytesReturned = 0;
            if (DeviceIoControl(hDevice, 0x4d014, destination, destination.Length, buffer2, buffer2.Length, ref lpBytesReturned, IntPtr.Zero) == 0)
            {
                return -1;
            }
            return lpBytesReturned;
        }

        [DllImport("shell32.dll")]
        public static extern int ShellExecute(IntPtr hwnd, string lpOperation, string lpFile, string lpParameters, string lpDirectory, int nShowCmd);
        private void slowDrive()
        {
            byte[] cmd = new byte[5];
            cmd[0] = 0x1b;
            cmd[1] = 1;
            cmd[4] = 0x20;
            this.send(this.driveToolStripComboBox.Text[0], cmd);
        }

        private void slowDrive(object sender, EventArgs e)
        {
            this.slowDrive();
        }

        private void spinDrive()
        {
            byte[] cmd = new byte[5];
            cmd[0] = 0x1b;
            cmd[1] = 1;
            cmd[4] = 1;
            this.send(this.driveToolStripComboBox.Text[0], cmd);
        }

        private void spinDrive(object sender, EventArgs e)
        {
            this.spinDrive();
        }

        private void stopDrive()
        {
            byte[] cmd = new byte[5];
            cmd[0] = 0x1b;
            cmd[1] = 1;
            cmd[4] = 0x30;
            this.send(this.driveToolStripComboBox.Text[0], cmd);
        }

        private void stopDrive(object sender, EventArgs e)
        {
            this.stopDrive();
        }

        public enum DriveTypes : uint
        {
            DRIVE_CDROM = 5,
            DRIVE_FIXED = 3,
            DRIVE_NO_ROOT_DIR = 1,
            DRIVE_RAMDISK = 6,
            DRIVE_REMOTE = 4,
            DRIVE_REMOVABLE = 2,
            DRIVE_UNKNOWN = 0
        }

        [StructLayout(LayoutKind.Sequential)]
        private class SCSI_PASS_THROUGH
        {
            private const int SCSI_IOCTL_DATA_IN = 1;
            public ushort Length = ((ushort)Marshal.SizeOf(typeof(MainForm.SCSI_PASS_THROUGH)));
            public byte ScsiStatus;
            public byte PathId;
            public byte TargetId;
            public byte Lun;
            public byte CdbLength;
            public byte SenseInfoLength = 0x18;
            public byte DataIn = 1;
            public uint DataTransferLength;
            public uint TimeOutValue = 10;
            public uint DataBufferOffset = ((uint)((int)Marshal.OffsetOf(typeof(MainForm.SCSI_PASS_THROUGH_WITH_BUFFERS), "ucDataBuf")));
            public uint SenseInfoOffset = ((uint)((int)Marshal.OffsetOf(typeof(MainForm.SCSI_PASS_THROUGH_WITH_BUFFERS), "ucSenseBuf")));
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x10)]
            public byte[] Cdb = new byte[0x10];
            public SCSI_PASS_THROUGH(byte target, byte cdbLen, uint dataTransferLength)
            {
                this.TargetId = target;
                this.CdbLength = cdbLen;
                this.DataTransferLength = dataTransferLength;
            }
        }

        [StructLayout(LayoutKind.Sequential)]
        private class SCSI_PASS_THROUGH_DIRECT
        {
            private const int SCSI_IOCTL_DATA_IN = 1;
            public ushort Length = ((ushort)Marshal.SizeOf(typeof(MainForm.SCSI_PASS_THROUGH_DIRECT)));
            public byte ScsiStatus;
            public byte PathId;
            public byte TargetId;
            public byte Lun;
            public byte CdbLength;
            public byte SenseInfoLength = 0x18;
            public byte DataIn = 1;
            public uint DataTransferLength;
            public uint TimeOutValue = 10;
            public byte[] DataBuffer;
            public uint SenseInfoOffset = ((uint)((int)Marshal.OffsetOf(typeof(MainForm.SCSI_PASS_THROUGH_WITH_BUFFERS), "ucSenseBuf")));
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x10)]
            public byte[] Cdb = new byte[0x10];
            public SCSI_PASS_THROUGH_DIRECT(byte target, byte cdbLen, uint dataTransferLength)
            {
                this.TargetId = target;
                this.CdbLength = cdbLen;
                this.DataTransferLength = dataTransferLength;
            }
        }

        [StructLayout(LayoutKind.Sequential)]
        private class SCSI_PASS_THROUGH_DIRECT_WITH_BUFFERS
        {
            public MainForm.SCSI_PASS_THROUGH_DIRECT spt;
            public uint Filler;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x20)]
            public byte[] ucSenseBuf;
            public SCSI_PASS_THROUGH_DIRECT_WITH_BUFFERS(byte target, byte cdbLen, uint dataTransferLength)
            {
                this.spt = new MainForm.SCSI_PASS_THROUGH_DIRECT(target, cdbLen, dataTransferLength);
                this.Filler = 0;
                this.ucSenseBuf = new byte[0x20];
            }
        }

        [StructLayout(LayoutKind.Sequential)]
        private class SCSI_PASS_THROUGH_WITH_BUFFERS
        {
            public MainForm.SCSI_PASS_THROUGH spt;
            public uint Filler;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x20)]
            public byte[] ucSenseBuf;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x200)]
            public byte[] ucDataBuf;
            public SCSI_PASS_THROUGH_WITH_BUFFERS(byte target, byte cdbLen, uint dataTransferLength)
            {
                this.spt = new MainForm.SCSI_PASS_THROUGH(target, cdbLen, dataTransferLength);
                this.Filler = 0;
                this.ucSenseBuf = new byte[0x20];
                this.ucDataBuf = new byte[0x200];
            }
        }

        [StructLayout(LayoutKind.Sequential)]
        private struct SPTDB
        {
            public short length;
            public byte ScsiStatus;
            public byte PathId;
            public byte TargetId;
            public byte Lun;
            public byte CdbLength;
            public byte SenseInfoLength;
            public byte DataIn;
            public int DataTransfertLength;
            public int TimeOutValue;
            public byte[] DataBuffer;
            public int SenseInfoOffset;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 10, ArraySubType = UnmanagedType.AsAny)]
            public byte[] cdb;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 4, ArraySubType = UnmanagedType.AsAny)]
            public byte[] Fill;
            [MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x23, ArraySubType = UnmanagedType.AsAny)]
            public byte[] SenseBuffer;
        }

        private enum SPTIDirection
        {
            SCSI_IOCTL_DATA_OUT,
            SCSI_IOCTL_DATA_IN,
            SCSI_IOCTL_DATA_UNSPECIFIED
        }
    }
}
